//+------------------------------------------------------------------+
//|                                          Momentum Candles v1.mq4 |
//|                                                              cja |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Lime
#property indicator_width1 3
#property indicator_width2 3
#property strict

extern int     candle_pipvalue      = 10;              // Candle pip value
extern int     hilow_pipvalue       = 15;              // High low/pip value
extern bool    alertsOn             = false;           // Turn alerts on?
extern bool    alertsOnCurrent      = false;           // Alerts on still opened bar?
extern bool    alertsMessage        = true;            // Alerts should display message?
extern bool    alertsSound          = false;           // Alerts should play a sound?
extern bool    alertsNotify         = false;           // Alerts should send a notification?
extern bool    alertsEmail          = false;           // Alerts should send an email?
extern string  soundFile            = "alert2.wav";    // Sound file for alerts

double buffer1[],buffer2[],trend[];


int init() 
{
   IndicatorBuffers(3);
   SetIndexBuffer(0, buffer1); SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1, buffer2); SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2, trend);
   
   myPoint = SetPoint();
   IndicatorShortName("Momentum Candles");
   
         
   return(0);
}
int deinit() { return(0);}
int start() 
{
   int counted_bars=IndicatorCounted();
      if (counted_bars < 0) return(-1);
      if (counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars - counted_bars,Bars-1);     
      
   //
   //
   //
   //
   //
         
   for(int i = limit; i >= 0; i--) 
   {
      double close = Close[i];
      double open  = Open[i];
      double high  = High[i];
      double low   = Low[i];

      buffer2[i] = buffer1[i] = EMPTY_VALUE;      
         if(open > close && (open-close)>=candle_pipvalue*myPoint && (high-low)>=hilow_pipvalue*myPoint) { buffer2[i] = close; buffer1[i] = open;  }
         if(open < close && (close-open)>=candle_pipvalue*myPoint && (high-low)>=hilow_pipvalue*myPoint) { buffer2[i] = close; buffer1[i] = open;  }
         trend[i] = (buffer1[i]!=EMPTY_VALUE) ? (buffer1[i]>buffer2[i]) ? -1 : 1 : i<Bars-1 ? trend[i+1] : 0;
   } 
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
         int whichBar = 1; if (alertsOnCurrent) whichBar = 0; 
         static string   _previousAlert1     = "";
         static datetime _previousAlertTime1 = 0;
            if (trend[whichBar] != trend[whichBar+1])
            {
               if (trend[whichBar] == 1) doAlert("trend changed up"  ,_previousAlert1,_previousAlertTime1,soundFile);
               if (trend[whichBar] ==-1) doAlert("trend changed down",_previousAlert1,_previousAlertTime1,soundFile);
            }         
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double myPoint;
double SetPoint() 
{ 
   double mPoint; 
   if (Digits < 4) 
         mPoint = 0.01; 
   else  mPoint = 0.0001; 
   return(mPoint); 
} 


//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat, string& previousAlert, datetime& previousTime, string _soundFile)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message = _Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" Momentum candles "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(_Symbol+" Momentum candles",message);
             if (alertsSound)   PlaySound(_soundFile);
      }
}